<template>
    <div>
        <form @submit.prevent="add">
            <div class="box">
                <label>
                    Check in: <br>
                    <input class="input" type="text" v-model="entry.check_in">
                </label>

                <label>
                    Check out: <br>
                    <input class="input" type="text" v-model="entry.check_out">
                </label>
            </div>

            <input class="button is-link" type="submit" value="Create Entry">
        </form>
    </div>
</template>

<script>
    import validate from 'validate.js';
    import axios from 'axios';

    export default {
        name: 'entries-new',
        data() {
            return {
                entry: {
                    check_in: '',
                    check_out: ''
                }
            }
        },
        computed: {
            currentUser() {
                return this.$store.getters.currentUser;
            }
        },
        methods: {
            add() {
                const constrains = this.getContrains();

                const errors = validate(this.$data.entry);

                if(errors) {
                    return;
                }

                axios.post(`/api/users/${this.currentUser.name}/entries`, this.$data.entry, {
                    headers: {
                        "Authorization": `Bearer ${this.currentUser.token}`
                    }
                })
                .then((res) => {
                    this.$router.push('/entries');
                });
            },
            getContrains() {
                return {
                    check_in: {
                        presense: true
                    },
                    check_out: {
                        presense: true
                    }
                }
            }
        }
    }
</script>